#!/usr/bin/perl

## Move Cert to Floppy
## (c) 1998 by Massimiliano Pala - Current Version 0.25a
## All rights Reserved.
##
## Licenced to Comune di Modena ( CA )

## Uses signedCGI modules (c) 1998 by Massimiliano Pala
## to generate, check and manipulate FORMs and SIGN Object
use signedCGI;

## Generate a new reference to signedCGI ( instance ) and a self reference
## to keep track of the URL this CGI is referring to (its own URL)
$signed = new signedCGI;

## Flush the output and prinf the content type for output
## to a Browser
$|=1;
print "Content-type: text/html\n\n";

print $signed->initPage(-title=>"Certificate Downloading Page",
                                 -BGCOLOR=>"#FFFFFF"); 

print "<FONT SIZE=18><CENTER>";
print "Attendere Prego, operazione in corso....<BR>Segue LOG completo delle operazioni...<HR WIDTH=80%>";
print "</CENTER></FONT>";

print "<PRE>\n";

&checkDisk();
&createTar();
&verifyTar();
&freeDisk();
&removeReqs();

print $signed->endPage();
exit 0;

## Subroutines Section for the CGI. Please note that the printError
## Function can be used in every CGI, unless you ## want a specific
## error trapping routine ( the routine here reported will soon be
## incorporate in the signedCGI.pm module located in /usr/local/lib/perl5
## on the Sun or in /usr/lib/perl5 on Linux )

sub checkDisk {

	my @keys;
	my $req;
	@key = @_;

	my @args;

	print "* Verifico l'esistenza del dischetto .......... ";

	$ret=`/bin/volcheck -v /dev/diskette0`;

	if ( "$ret" =~ m/\/dev\/diskette0 has media/ ) {
		print "Ok.\n";
		return;
	} else {
		print "Failed!\n\n\t  Errore Riportato : Floppy non inserito!\n\n";
		print $ret;
		&exitCGI();
	}
	return;
}

sub createTar {

	print "* Sto creando l'archivio dei certificati su supporto removibile ....... ";
	$dat = `date`;
	$dat =~ s/(MET\ |DST\ )//g;
	$dat =~ s/(\ |\:)/\_/g;

	opendir ( DIR , "/vol/dev/diskette0" );
	@diskLabel = grep(!/^(\.|index.html)/, readdir( DIR ) );
	closedir( DIR );
	print $diskLabel;

	$ret = `( cd /export/home/lioy/ca/reqs/signed; /usr/local/bin/tar cvfp /vol/dev/diskette0/$diskLabel[0] *_cert.pem )`;

        if ( "$ret" =~ "Invalid" ) {
                print "Failed!\n\n";
                print "\t  Errore Riportato : $!\n\n";
                &exitCGI();
        } else {
                print "Ok.\n";
                return;
        }

        return;
}
              
sub verifyTar {

        print "* Sto verificando l'archivio dei certificati ....... ";
        $dat = `date`;
	$dat =~ s/(MET\ |DST\ )//g;
	$dat =~ s/(\ |\:)/\_/g;

        $ret = `/usr/local/bin/tar tvfp /vol/dev/diskette0/unlabeled`;

        if ( "$ret" =~ "rror" ) {
                print "Failed!\n\n";
                print "\t  Errore Riportato : $!\n\n";
                &exitCGI();
        } else {
                print "Ok.\n";
                return;
        }

        return;
}

sub removeReqs {

        print "* Sto eliminando i certificati gia' trasferiti ....... ";

        $ret = `/bin/rm -f /export/home/lioy/ca/reqs/signed/*`;

        if ( "$ret" =~ "rror" ) {
                print "Failed!\n\n";
                print "\t  Errore Riportato : $!\n\n";
                &exitCGI();
        } else {
                print "Ok.\n";
                return;
        }

        return;
}

sub copyTar {

        print "* Sto copiando l'archivio delle richieste ....... ";
        $dat = `date`;
	$dat =~ s/(MET\ |DST\ )//g;
	$dat =~ s/(\ |\:)/\_/g;
        
	## $ret = `/usr/local/bin/tar cvfpz /export/home/raclient/archivied/ra_$dat.tar.gz /export/home/raclient/processed/*`;
        $ret = `/bin/cp /export/home/raclient/processed/* /export/home/raclient/archivied`;
	print "Ok.\n";
      
	## if ( "$ret" eq "" ) {
        ##         print "Ok.\n";
        ##         return;
        ## } else {
        ##         print "Failed!\n\n";
        ##         print "\t  Errore Riportato : $!\n\n";
        ##         &exitCGI();
        ##  }

        return;
}

sub freeDisk {

        print "* Sto liberando le risorse ....... ";
        ## `eject floppy &`;
	print "Ok.\n";

        return;
	
}     

sub exitCGI {

	exit;
}

sub closePage {

	print "\n\n";
	print "</PRE><CENTER><HR WIDTH=80%></CENTER>\n";
	print "<CENTER>&copy; 1998 by Massimiliano Pala</CENTER>\n";

	return;
}

sub flushCache {

	for ( $i=0; $i<200; $i++ ) {
                print "<!------ Timing Flushing Output for Netscape Technology -----!\n>";
        }
} 
