#!/bin/perl 

## Get the User Certificate
## (c) 1998 by Massimiliano Pala - Ver 1.0
## All Rights Reserved
##
## Licenced to Comune di Modena 

## Initialization parameters, requirement, and so on.
require "lib/cgi-lib.pl";

my $cert="";
my $mimetype = "Content-type: application/x-x509-__XXX__-cert\n\n";
my $bgcert = '-----BEGIN CERTIFICATE-----';
my $endcert = '-----END CERTIFICATE-----';

## Flush the output buffer
$|=1;

## print "Content-type: text/html\n\n";

## We are about to print output, we need the type
## Let's use the new signedCGI.pm module
use signedCGI;
$signed = new signedCGI;

## Let's get parameters
$type    = 'user';
$serial  = $signed->param('serial');
$certdir = '/usr/local/digid/apache/callisto/www-idd/htdocs/certs';

$filename = "$certdir/" . $serial . "_cert.pem";
open( FD, "<$filename") || &sendPage("getid_error.html");

## Now we must take different path for we can give certs for user/ca
## or whatever we want.
if ( "$type" eq "user" ) {
	my $tmp = 0;
	while( $line=<FD> ) {
		$tmp=1 if ( $line =~ /$bgcert/ );
		$cert .= $line if ( $tmp > 0 );
	};

	$mimetype =~ s/__XXX__/$type/g;
}

## If we want the Text part of the Certificate, we need to cut
## the bottom of the file.
if ( "$type" eq "txt" ) {
	my $tmp = 1;
	while( $line=<FD> ) {
		$tmp=0 if ( $line =~ /$bgcert/ );
		$cert .= $line if ( $tmp > 0 );
	};

	$mimetype = "Content-type: text/html\n\n";
	$mimetype .= "<PRE>\n";
}

close FD;

print "$mimetype";
print "$cert";

exit 0;

## Subroutines Section : expecially there is room for
## the erro page transmitting.

sub sendPage {
	my @keys;
	@keys = @_ ;
	$filename = $keys[0];

	print "Content-type: text/html\n\n";
	open ( FD, "<$filename");
	while ( $p = <FD> ) {
		print "$p";
	};

	exit 0;
}
