#!/bin/perl 

## Send Certificates Tool
## (c) 1999 by Massimiliano and the OpenCA Staff.

## Flush the output stream
$|=1;

## Modules import & html Header Setup
use OpenCA::TRIStateCGI;
$query = new OpenCA::TRIStateCGI;

## Variables Definition
$fileError="<H1>604 Internal Server Error</H1>Can not access file : ";

$PATH= $query -> path_info();
$microsoft = "MSIE";
$netscape = "Mozilla";
$PATH="cacert.der";

## Error Messages
##$err1  = '<H3>BROWSER ERROR: the variable HTTP_USER_AGENT is not set</H3>';
##$err2  = '<H1>ATTENZIONE: non &egrave; possibile scaricare il certificato con questo tipo di client WWW</H1>'."\n";
##$err2 .= 'Sono necessarie le caratteristiche di sicurezza supportate solamente dai client WWW:<BR><UL>'."\n";

$err1 = "UserAgentError.html";
$err2 = "BrowserError.html";

## Listings of Supported Browsers
%valid_ver = (
  $microsoft => 4.0,
  $netscape => 2.0
	 );

## Get the AGENT TYPE ( Browser )
$user_agent = $query -> user_agent();

if ( "$user_agent" eq "" ) {
	&sendPage($err1);
	exit 0;
};

## Get the Browser Name and the Version
if ( $user_agent =~ /(MSIE)/ ) {
($browser, $ver) =
	$user_agent =~ /(MSIE)\ (\d+\.\d*|\.\d+)/;
} else {
($browser, $ver) =
	$user_agent =~ m-(^[^/]+)/(\d+\.\d*|\.\d+)-;
};
	 
if ( $ver >= $valid_ver{"$browser"} ) {
	##if ($browser eq $microsoft) {
	##	$PATH=$icerootCAcert;
	##	&put_cert;
	##} else {
	##	&put_cert;
	##}
	put_cert();
}  else {
	&sendPage($err2);
}

## Subroutines Section (Last Modified on 08 September 1998)
## Changes by Massimiliano Pala (madwolf@comune.modena.it)

sub put_cert  {

	print "Content-Type: application/x-x509-ca-cert\n\n";
	open (FD ,"$PATH") || print "Errore";

	while (<FD>) {
		print $_;
	}

	close FD
}

sub sendPage {
	my @keys;
	my $ret;
	@keys = @_;
	
	print "Content-Type: text/html\n\n";

	$fileName  = "$baseErrorPath";
	$fileName .= $keys[0];

	open ( FD, "$fileName" ) || print "$fileError"."($fileName)";
	while (<FD>) {
		print $_;
	};
	close FD;
	
	return; 
}
